SystemOrganization addCategory: #'SCouchDB-Application-Examples'!
SystemOrganization addCategory: #'SCouchDB-Application-Examples-Albums'!
SystemOrganization addCategory: #'SCouchDB-Application-Evently-Examples'!
SystemOrganization addCategory: #'SCouchDB-Application-Core'!
SystemOrganization addCategory: #'SCouchDB-Application-Evently-Core'!

!JsonObject methodsFor: '*scouchdb-application-core' stamp: 'JesusMariAguirre 5/14/2012 15:41'!
addAttachmentAt: name put:anAttachment
self at:'_attachments' ifAbsent:[ self at:'_attachments' put:JsonObject new].
(self at: '_attachments') at:name put:anAttachment
! !

!JsonObject methodsFor: '*scouchdb-application-core' stamp: 'JesusMari 12/26/2012 17:42'!
id
^self at:'_id' ifAbsent:[nil] ! !

!JsonObject methodsFor: '*scouchdb-application-core' stamp: 'JesusMariAguirre 5/14/2012 15:42'!
removeAttachment:anAttachment
^(self at:'_attachments') removeKey:anAttachment ifAbsent:[nil]! !

!JsonObject methodsFor: '*scouchdb-application-core' stamp: 'JesusMari 12/26/2012 17:43'!
rev
^self at:'_rev' ifAbsent:[nil] ! !

JsonObject subclass: #SCEvently
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-Application-Evently-Core'!

SCEvently subclass: #EventlyAccount
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-Application-Evently-Core'!

!EventlyAccount methodsFor: 'as yet unclassified' stamp: 'JesusMari 9/17/2012 15:02'!
initialize:size
super initialize:size.

self renderAccountEventOn:self.
self renderLoggedinEventOn: self.
self renderLoggedoutEventOn: self.
self renderLoginFormEventOn:self.
self renderSignUnFormEventOn:self.
self renderItemsEventOn:self.
self renderProfileEventOn:self.
! !

!EventlyAccount methodsFor: 'as yet unclassified' stamp: 'JesusMari 9/16/2012 00:29'!
renderAccountEventOn:evently

(evently at:'account')  onEvent:'_init' do:
'function() {
  var elem = $(this);
  $$(this).userCtx = null;
  $.couch.session({
    success : function(r) {
      var userCtx = r.userCtx;
      if (userCtx.name) {
        elem.trigger("loggedIn", [r]);
      } else if (userCtx.roles.indexOf("_admin") !!= -1) {
        elem.trigger("adminParty");
      } else {
        elem.trigger("loggedOut");
      };
    }
  });
}' ;
onEvent:'adminParty' mustache:
'<p><strong>Admin party, everyone is admin!!</strong> Fix this in <a href="/_utils/index.html">Futon</a> before proceeding.</p>';

onEvent:'doLogin' do:
'function(e, name, pass) {
  var elem = $(this);
  $.couch.login({
    name : name,
    password : pass,
    success : function(r) {
      elem.trigger("_init")
    }
  });      
}';
onEvent:'doLogout' do:
'function() {
  var elem = $(this);
  $.couch.logout({
    success : function() {
      elem.trigger("_init");
    }
  });
}';
onEvent:'doSignup' do:
'function(e, name, pass) {
  var elem = $(this);
  $.couch.signup({
    name : name
  }, pass, {
    success : function() {
      elem.trigger("doLogin", [name, pass]);
    }
  });
}'.! !

!EventlyAccount methodsFor: 'as yet unclassified' stamp: 'JesusMari 9/16/2012 00:29'!
renderItemsEventOn:evently
((evently at:'items' onEvent:'_changes') 
data:'function(data) {
  // $.log(data)
  var p;
  return {
    items : data.rows.map(function(r) {
      p = (r.value && r.value.profile) || {};
      p.message = r.value && r.value.message;
      return p;
    })
  }
};'
mustache:'<p>Customize this format here: <tt>ddoc.evently.items._changes.mustache</tt></p>
<h3>Recent Messages</h3>
<ul>
  {{#items}}
    <li>
      <div class="avatar">
        {{#gravatar_url}}<img src="{{gravatar_url}}" alt="{{name}}"/>{{/gravatar_url}}
        <div class="name">
          {{nickname}}
        </div>
      </div>
      <p>{{message}}</p>
      <div style="clear:left;"></div>
    </li>
  {{/items}}
</ul>
<p><em>Protip:</em> If you setup continuous replication between this database and a remote one, this list will reflect remote changes in near real-time.</p>
<p>This would be a good place to add pagination.</p>')

query view:'recent-items'; descending: true;limit: 50.! !

!EventlyAccount methodsFor: 'as yet unclassified' stamp: 'JesusMari 9/16/2012 00:15'!
renderLoggedinEventOn: evently
(evently at:'account' onEvent:'loggedIn')
selector: 'a[href=#logout]' 
onClick:(Array with:'doLogout') ;
data:'function(e, r) {
  return {
    name : r.userCtx.name,
    uri_name : encodeURIComponent(r.userCtx.name),
    auth_db : encodeURIComponent(r.info.authentication_db)
  };
}'
mustache:'<span>Welcome 
<a target="_new" href="/_utils/document.html?{{auth_db}}/org.couchdb.user%3A{{uri_name}}">{{name}}</a>!! 
<a href="#logout">Logout?</a>
</span>';
onEvent:'after' do:'function(e, r) {
  $$(this).userCtx = r.userCtx;
  $$(this).info = r.info;
};'.
! !

!EventlyAccount methodsFor: 'as yet unclassified' stamp: 'JesusMari 9/12/2012 18:01'!
renderLoggedoutEventOn: evently
(evently at:'account' onEvent:'loggedOut')
mustache: '<a href="#signup">Signup</a> or <a href="#login">Login</a>';
selector: 'a[href=#signup]' onClick:(Array with:'signupForm');
selector: 'a[href=#login]' onClick:(Array with:'loginForm').

! !

!EventlyAccount methodsFor: 'as yet unclassified' stamp: 'JesusMari 9/12/2012 18:01'!
renderLoginFormEventOn: evently
(evently at:'account' onEvent:'loginForm')
selector: 'a[href=#signup]' onClick:(Array with:'signupForm');
selector: 'form' onSubmit:'function(e) {
 		var name = $(''input[name=name]'', this).val(),
    		pass = $(''input[name=password]'', this).val();              
  		$(this).trigger(''doLogin'', [name, pass]);
  		return false;
	}';
mustache:'<form>
  <label for="name">Name</label> <input type="text" name="name" value="" autocapitalize="off" autocorrect="off">
  <label for="password">Password</label> <input type="password" name="password" value="">
  <input type="submit" value="Login">
  <a href="#signup">or Signup</a>
</form>';
onEvent:'after' do:'function() {
  $("input[name=name]", this).focus();
}'.

! !

!EventlyAccount methodsFor: 'as yet unclassified' stamp: 'JesusMari 9/16/2012 00:18'!
renderProfileEventOn:evently
((evently at:'profile') onEvent:'loggedIn' do:'function(e, r) {
  	var userCtx = r.userCtx;
  	var widget = $(this);
  	// load the profile from the user doc
  	var db = $.couch.db(r.info.authentication_db);
  	var userDocId = "org.couchdb.user:"+userCtx.name;
  	db.openDoc(userDocId, {
    		success : function(userDoc) {
      		var profile = userDoc["couch.app.profile"];
      		if (profile) {
        		// we copy the name to the profile so it can be used later
        		// without publishing the entire userdoc (roles, pass, etc)
        		profile.name = userDoc.name;
        		$$(widget).profile = profile;
        		widget.trigger("profileReady", [profile]);
      		} else {
        		widget.trigger("noProfile", [userCtx]);
      	}
    	}
  });
}';
onEvent:'loggedOut' mustache:'<p>Please log in to see your profile.</p>')
	onEvent:'after' do:'function() {  $$(this).profile = null;};'.

((evently at:'profile' onEvent:'noProfile')
data:'function(e, userCtx) {
  return userCtx;
}'
mustache:'<form>
  <p>Hello {{name}}, Please setup your user profile.</p>
  <label for="nickname">Nickname 
    <input type="text" name="nickname" value=""></label>
  <label for="email">Email (<em>for <a href="http://gravatar.com">Gravatar</a></em>)
    <input type="text" name="email" value=""></label>
  <label for="url">URL 
    <input type="text" name="url" value=""></label>
  <input type="submit" value="Go &rarr;">
  <input type="hidden" name="userCtxName" value="{{name}}" id="userCtxName">
</form>';
onEvent:'_init')
selector: 'form' onSubmit:'function() {
  var md5 = $$(this).app.require("vendor/couchapp/lib/md5");
  
  // TODO this can be cleaned up with docForm?
  // it still needs the workflow to edit an existing profile
  var name = $("input[name=userCtxName]",this).val();
  var newProfile = {
    rand : Math.random().toString(), 
    nickname : $("input[name=nickname]",this).val(),
    email : $("input[name=email]",this).val(),
    url : $("input[name=url]",this).val()
  }, widget = $(this);

  // setup gravatar_url
  if (md5) {
    newProfile.gravatar_url = ''http://www.gravatar.com/avatar/''+md5.hex(newProfile.email || newProfile.rand)+''.jpg?s=40&d=identicon'';    
  }

  // store the user profile on the user account document
  $.couch.userDb(function(db) {
    var userDocId = "org.couchdb.user:"+name;
    db.openDoc(userDocId, {
      success : function(userDoc) {
        userDoc["couch.app.profile"] = newProfile;
        db.saveDoc(userDoc, {
          success : function() {
            newProfile.name = userDoc.name;
            $$(widget).profile = newProfile;
            widget.trigger("profileReady", [newProfile]);
          }
        });
      }
    });
  });
  return false;
}'.


(((evently at:'profile' onEvent:'profileReady')
data:'function(e, p) {
  return p
}
'
mustache:'<div class="avatar">
  {{#gravatar_url}}<img src="{{gravatar_url}}"/>{{/gravatar_url}}
  <div class="name">
    {{nickname}}
  </div>
</div>
<p>Hello {{nickname}}!!</p>
<div style="clear:left;"></div>') 
onEvent:'_init') 
selector: 'form' 
onSubmit: 'function() {
  var form = $(this);
  var fdoc = form.serializeObject();
  fdoc.created_at = new Date();
  fdoc.profile = $$("#profile").profile;
  $$(this).app.db.saveDoc(fdoc, {
    success : function() {
      form[0].reset();
    }
  });
  return false;
};'; onEvent:'after' do:'function(e, p) {
  $$(this).profile = p;
};'


! !

!EventlyAccount methodsFor: 'as yet unclassified' stamp: 'JesusMari 9/16/2012 00:05'!
renderSignUnFormEventOn: evently
(evently at:'account' onEvent:'signupForm')
selector: 'a[href=#login]' onClick:(Array with:'loginForm');
selector: 'form' onSubmit:'function(e) {
 		var name = $(''input[name=name]'', this).val(),
    		pass = $(''input[name=password]'', this).val();              
  		$(this).trigger(''doSignup'', [name, pass]);
  		return false;
	}';
mustache:'<form>
  <label for="name">Name</label> <input type="text" name="name" value="" autocapitalize="off" autocorrect="off">
  <label for="password">Password</label> <input type="password" name="password" value="">
  <input type="submit" value="Signup">
  <a href="#login">or Login</a>
</form>';
onEvent:'after' do:'function() {
  $("input[name=name]", this).focus();
}'
! !

!SCEvently methodsFor: 'accessing' stamp: 'JesusMari 9/6/2012 23:59'!
at:anEventlyName
^super at:(anEventlyName) ifAbsent:[
	self at:(anEventlyName) put:SCEvently new] ! !

!SCEvently methodsFor: 'accessing' stamp: 'JesusMari 9/6/2012 23:55'!
at:anEventlyName onEvent:anEvent
| e |
e:=self at:(anEventlyName).
^e onEvent:anEvent! !

!SCEvently methodsFor: 'accessing' stamp: 'JesusMari 9/6/2012 23:56'!
at:anEventlyName onEvent:anEvent data:aDataString
| e |
e:=self at:anEventlyName onEvent:anEvent.
e data:aDataString.
^e
! !

!SCEvently methodsFor: 'accessing' stamp: 'JesusMari 9/6/2012 23:56'!
at:anEventlyName onEvent:anEvent data:aDataString mustache:aMustacheString
| e |
e:=self at:anEventlyName onEvent:anEvent.
e data:aDataString.
e mustache:aMustacheString.
^e

! !

!SCEvently methodsFor: 'accessing' stamp: 'JesusMari 9/6/2012 23:57'!
at:anEventlyName onEvent:anEvent do:anObject
| e |
e:=self at:(anEventlyName).
^e at:anEvent put:anObject! !

!SCEvently methodsFor: 'accessing' stamp: 'JesusMari 9/6/2012 23:57'!
at:anEventlyName onEvent:anEvent mustache:aMustacheString
| e |
e:=self at:anEventlyName onEvent:anEvent.
e mustache:aMustacheString.
^e
! !

!SCEvently methodsFor: 'accessing' stamp: 'JesusMari 9/6/2012 23:58'!
at:anEventlyName onEvent:anEvent  mustache:aMustacheString data:aDataString
| e |
e:=self at:anEventlyName onEvent:anEvent.
e data:aDataString.
e mustache:aMustacheString.
^e
! !

!SCEvently methodsFor: 'accessing' stamp: 'JesusMari 9/6/2012 23:59'!
at:anEventlyName onEvent:anEvent selector:aJQuerySelector
| e |
e:=self at:(anEventlyName).
^(e onEvent:anEvent ) selector:aJQuerySelector! !

!SCEvently methodsFor: 'accessing' stamp: 'JesusMari 9/1/2012 12:34'!
data: aStringData
self at:'data' put:aStringData! !

!SCEvently methodsFor: 'accessing' stamp: 'JesusMari 9/16/2012 00:15'!
data: aStringData mustache:aMustacheTemplate
self data:aStringData.
self mustache:aMustacheTemplate! !

!SCEvently methodsFor: 'accessing' stamp: 'JesusMari 9/1/2012 22:52'!
mustache: aMustacheTemplate
(aMustacheTemplate isKindOf:MustacheTemplate)
ifTrue:[self at:'mustache' put: aMustacheTemplate render]
ifFalse:[self at:'mustache' put: aMustacheTemplate asString]! !

!SCEvently methodsFor: 'accessing' stamp: 'JesusMari 9/16/2012 00:15'!
mustache:aMustacheTemplate data: aStringData 
self data:aStringData.
self mustache:aMustacheTemplate! !

!SCEvently methodsFor: 'accessing' stamp: 'JesusMari 9/7/2012 00:25'!
onEvent:anEventlyEvent
^self at:anEventlyEvent ! !

!SCEvently methodsFor: 'accessing' stamp: 'JesusMari 9/7/2012 00:30'!
onEvent:anEvent data:aDataString
| e |
e:=self onEvent:anEvent.
e data:aDataString.
^e
! !

!SCEvently methodsFor: 'accessing' stamp: 'JesusMari 9/7/2012 00:30'!
onEvent:anEvent data:aDataString mustache:aMustacheString
| e |
e:=self onEvent:anEvent.
e data:aDataString.
e mustache:aMustacheString.
^e

! !

!SCEvently methodsFor: 'accessing' stamp: 'JesusMari 9/12/2012 17:48'!
onEvent:anEvent do:anObject

self at:anEvent put:anObject.
^self at:anEvent ! !

!SCEvently methodsFor: 'accessing' stamp: 'JesusMari 9/7/2012 00:31'!
onEvent:anEvent mustache:aMustacheString
| e |
e:=self  onEvent:anEvent.
e mustache:aMustacheString.
^e
! !

!SCEvently methodsFor: 'accessing' stamp: 'JesusMari 9/7/2012 00:31'!
onEvent:anEvent  mustache:aMustacheString data:aDataString
| e |
e:=self onEvent:anEvent.
e data:aDataString.
e mustache:aMustacheString.
^e
! !

!SCEvently methodsFor: 'accessing' stamp: 'JesusMari 9/7/2012 00:35'!
onEvent:anEvent selector:aJQuerySelector
| e |

^(self onEvent:anEvent ) selector:aJQuerySelector! !

!SCEvently methodsFor: 'accessing' stamp: 'JesusMari 9/17/2012 01:01'!
query
^ self at:'query' ifAbsent:[self at:'query' put:SCEventlyQuery new]! !

!SCEvently methodsFor: 'accessing' stamp: 'JesusMari 9/17/2012 01:00'!
selector:aSelector
^self selectors at:aSelector ifAbsent:[self selectors at:aSelector put:SCEventlySelector new]! !

!SCEvently methodsFor: 'form-events' stamp: 'JesusMari 9/4/2012 19:16'!
selector:aSelector onBlur: eventHandler
self selector:aSelector  onEvent:'blur' do:eventHandler! !

!SCEvently methodsFor: 'form-events' stamp: 'JesusMari 9/4/2012 19:16'!
selector: aSelector onChange: eventHandler
self selector:aSelector  onEvent:'change' do:eventHandler! !

!SCEvently methodsFor: 'mouse-events' stamp: 'JesusMari 9/4/2012 19:25'!
selector:aSelector onClick: eventHandler
self selector:aSelector onEvent:'click' do:eventHandler! !

!SCEvently methodsFor: 'mouse-events' stamp: 'JesusMari 9/4/2012 19:22'!
selector:aSelector onDblClick: eventHandler
self selector:aSelector onEvent:'dblclick' do:eventHandler! !

!SCEvently methodsFor: 'browser-events' stamp: 'JesusMari 9/4/2012 19:13'!
selector: aSelector onError: eventHandler
self selector:aSelector onEvent:'error' do:eventHandler! !

!SCEvently methodsFor: 'accessing' stamp: 'JesusMari 9/4/2012 17:35'!
selector:aSelector onEvent:jqueryEvent do:eventlyEvent

^	(self selector:aSelector) onEvent:jqueryEvent do:eventlyEvent ! !

!SCEvently methodsFor: 'form-events' stamp: 'JesusMari 9/4/2012 19:17'!
selector:aSelector onFocus: eventHandler
self selector:aSelector onEvent:'focus' do:eventHandler! !

!SCEvently methodsFor: 'keyboard-events' stamp: 'JesusMari 9/4/2012 19:18'!
selector:aSelector onFocusIn: eventHandler
self selector:aSelector onEvent:'focusin' do:eventHandler! !

!SCEvently methodsFor: 'keyboard-events' stamp: 'JesusMari 9/4/2012 19:19'!
selector:aSelector onFocusOut: eventHandler
self selector:aSelector onEvent:'focusout' do:eventHandler! !

!SCEvently methodsFor: 'mouse-events' stamp: 'JesusMari 9/4/2012 19:22'!
selector:aSelector onHover: eventHandler
self selector:aSelector onEvent:'hover' do:eventHandler! !

!SCEvently methodsFor: 'keyboard-events' stamp: 'JesusMari 9/4/2012 19:19'!
selector:aSelector onKeyDown: eventHandler
self selector:aSelector onEvent:'keydown' do:eventHandler! !

!SCEvently methodsFor: 'keyboard-events' stamp: 'JesusMari 9/4/2012 19:19'!
selector:aSelector onKeyPress: eventHandler
self selector:aSelector onEvent:'keypress' do:eventHandler! !

!SCEvently methodsFor: 'keyboard-events' stamp: 'JesusMari 9/4/2012 19:20'!
selector:aSelector onKeyUp: eventHandler
self selector:aSelector onEvent:'keyup' do:eventHandler! !

!SCEvently methodsFor: 'document-events' stamp: 'JesusMari 9/4/2012 19:15'!
selector:aSelector onLoad: eventHandler
self selector:aSelector  onEvent:'load' do:eventHandler! !

!SCEvently methodsFor: 'mouse-events' stamp: 'JesusMari 9/4/2012 19:23'!
selector:aSelector onMouseDown: eventHandler
self selector:aSelector onEvent:'mousedown' do:eventHandler! !

!SCEvently methodsFor: 'mouse-events' stamp: 'JesusMari 9/4/2012 19:23'!
selector:aSelector onMouseEnter: eventHandler
self selector:aSelector onEvent:'mouseenter' do:eventHandler! !

!SCEvently methodsFor: 'mouse-events' stamp: 'JesusMari 9/4/2012 19:23'!
selector:aSelector onMouseLeave: eventHandler
self selector:aSelector onEvent:'mouseleave' do:eventHandler! !

!SCEvently methodsFor: 'mouse-events' stamp: 'JesusMari 9/4/2012 19:23'!
selector:aSelector onMouseMove: eventHandler
self selector:aSelector onEvent:'mousemove' do:eventHandler! !

!SCEvently methodsFor: 'mouse-events' stamp: 'JesusMari 9/4/2012 19:23'!
selector:aSelector onMouseOut: eventHandler
self selector:aSelector onEvent:'mouseout' do:eventHandler! !

!SCEvently methodsFor: 'mouse-events' stamp: 'JesusMari 9/4/2012 19:23'!
selector:aSelector onMouseOver: eventHandler
self selector:aSelector onEvent:'mouseover' do:eventHandler! !

!SCEvently methodsFor: 'mouse-events' stamp: 'JesusMari 9/4/2012 19:24'!
selector:aSelector onMouseUp: eventHandler
self selector:aSelector onEvent:'mouseup' do:eventHandler! !

!SCEvently methodsFor: 'document-events' stamp: 'JesusMari 9/4/2012 19:15'!
selector:aSelector onReady: eventHandler
self selector:aSelector onEvent:'ready' do:eventHandler! !

!SCEvently methodsFor: 'browser-events' stamp: 'JesusMari 9/4/2012 19:13'!
selector:aSelector onResize: eventHandler
self selector:aSelector  onEvent:'resize' do:eventHandler! !

!SCEvently methodsFor: 'browser-events' stamp: 'JesusMari 9/4/2012 19:14'!
selector:aSelector onScroll: eventHandler
self selector:aSelector onEvent:'scroll' do:eventHandler! !

!SCEvently methodsFor: 'form-events' stamp: 'JesusMari 9/4/2012 19:17'!
selector:aSelector onSelect: eventHandler
self selector:aSelector  onEvent:'select' do:eventHandler! !

!SCEvently methodsFor: 'form-events' stamp: 'JesusMari 9/4/2012 19:16'!
selector:aSelector onSubmit: eventHandler
self selector:aSelector  onEvent:'submit' do:eventHandler! !

!SCEvently methodsFor: 'document-events' stamp: 'JesusMari 9/4/2012 19:15'!
selector:aSelector onUnload: eventHandler
self selector:aSelector onEvent:'unload' do:eventHandler! !

!SCEvently methodsFor: 'private' stamp: 'JesusMari 9/1/2012 12:40'!
selectors
^self at:'selectors' ifAbsent:[self at:'selectors' put:(JsonObject new)].! !

JsonObject subclass: #SCEventlyQuery
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-Application-Evently-Core'!

!SCEventlyQuery methodsFor: 'as yet unclassified' stamp: 'JesusMari 9/17/2012 00:08'!
descending: aBoolean
self at:'descending' put:aBoolean! !

!SCEventlyQuery methodsFor: 'as yet unclassified' stamp: 'JesusMari 6/18/2012 05:52'!
limit: anInteger
self at:'limit' put: anInteger! !

!SCEventlyQuery methodsFor: 'as yet unclassified' stamp: 'JesusMari 6/18/2012 05:51'!
view: aViewName
self at:'view' put:aViewName! !

JsonObject subclass: #SCEventlySelector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-Application-Evently-Core'!

!SCEventlySelector methodsFor: 'accessing' stamp: 'JesusMari 9/4/2012 17:35'!
onEvent:event  do:jscriptFunction

self at:event put: jscriptFunction.
		! !

JsonObject subclass: #SCouchDBAttachment
	instanceVariableNames: 'name fileName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-Application-Core'!

!SCouchDBAttachment class methodsFor: 'as yet unclassified' stamp: 'JesusMariAguirre 5/16/2012 13:22'!
fromFile:aFileName
^self fromFile:aFileName includeDoc:true ! !

!SCouchDBAttachment class methodsFor: 'as yet unclassified' stamp: 'JesusMari 7/27/2012 10:25'!
fromFile:aFileName includeDoc:aBoolean
| attch aStream|

attch:=self new.
aStream := StandardFileStream readOnlyFileNamed: aFileName .
aBoolean ifFalse:[attch contentLength: aStream size].
attch contentType: (MIMEDocument guessTypeFromName: aFileName) asString.
attch fileName:aFileName.
aBoolean ifFalse:[
	attch at:'follows' put:true.
	attch removeKey:'data'].
aStream close.
^attch! !

!SCouchDBAttachment methodsFor: 'as yet unclassified' stamp: 'JesusMariAguirre 5/16/2012 10:50'!
at:obj
(obj='data') 
ifTrue:[^self data].
^super at:obj
! !

!SCouchDBAttachment methodsFor: 'as yet unclassified' stamp: 'JesusMariAguirre 5/13/2012 12:34'!
contentLength
^self at:'length'! !

!SCouchDBAttachment methodsFor: 'as yet unclassified' stamp: 'JesusMariAguirre 5/13/2012 12:34'!
contentLength:lenght
self at:'length' put:lenght! !

!SCouchDBAttachment methodsFor: 'as yet unclassified' stamp: 'JesusMariAguirre 5/16/2012 09:51'!
contentType
^self at:'content_type'! !

!SCouchDBAttachment methodsFor: 'as yet unclassified' stamp: 'JesusMariAguirre 5/16/2012 09:51'!
contentType:type
self at:'content_type' put:type! !

!SCouchDBAttachment methodsFor: 'as yet unclassified' stamp: 'JesusMariAguirre 5/16/2012 10:39'!
data

        ^ (Base64MimeConverter mimeEncode: self stream multiLine: false) contents! !

!SCouchDBAttachment methodsFor: 'as yet unclassified' stamp: 'JesusMariAguirre 5/14/2012 11:33'!
fileName
^fileName! !

!SCouchDBAttachment methodsFor: 'as yet unclassified' stamp: 'JesusMariAguirre 5/14/2012 11:33'!
fileName:aName
fileName:=aName! !

!SCouchDBAttachment methodsFor: 'as yet unclassified' stamp: 'JesusMariAguirre 5/16/2012 10:47'!
initialize:size
super initialize:size.
self at:'data' put:nil.! !

!SCouchDBAttachment methodsFor: 'as yet unclassified' stamp: 'JesusMariAguirre 5/16/2012 11:11'!
jsonWriteOn: aStream

	| needComma |
	needComma := false.
	aStream nextPut: ${.
	self associationsDo: [ :assoc |
		needComma
			ifTrue: [ aStream nextPut: $, ]
			ifFalse: [ needComma := true ].
		assoc key jsonWriteOn: aStream.
		aStream nextPut: $:.
		(assoc key  = 'data') ifTrue:[ self data jsonWriteOn: aStream ]
							 ifFalse:[assoc value jsonWriteOn: aStream]
		 ].
	aStream nextPut: $}.! !

!SCouchDBAttachment methodsFor: 'as yet unclassified' stamp: 'JesusMariAguirre 5/14/2012 11:11'!
name
^name! !

!SCouchDBAttachment methodsFor: 'as yet unclassified' stamp: 'JesusMariAguirre 5/14/2012 11:11'!
name:aName
name:=aName! !

!SCouchDBAttachment methodsFor: 'as yet unclassified' stamp: 'JesusMariAguirre 5/14/2012 19:16'!
stream
| aStream a |
a:=StandardFileStream readOnlyFileNamed:fileName .
a binary.
^a

! !

SCouchDBAppWrapper subclass: #SCouchDBApp
	instanceVariableNames: 'database dbAdaptor appName runner includeDocs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-Application-Core'!

SCouchDBApp subclass: #Albums
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-Application-Examples-Albums'!

!Albums methodsFor: 'as yet unclassified' stamp: 'JesusMari 1/14/2013 11:00'!
initEvently

self initEventlyFooters.
self initEventlyAlbumView.
self initEventlyAlbumDelete.
self initEventlyLoginDialog.
self initEventlyAlbumEdit.
self initEventlyAlbumAdd. 
self initEventlyAlbumSearch! !

!Albums methodsFor: 'as yet unclassified' stamp: 'JesusMari 9/7/2012 04:44'!
initEventlyAlbumAdd

(self evently at:'albumAdd' )
		onEvent:'addCancel' do:
		'function( event ){
	   		$.mobile.changePage( "/albums/_design/albums/_list/albumIndex/albums", "slide", true, true );
    		}'; 
		onEvent:'addConfirm' do:
		'function(e){
		var document = {};
            document.artist = $("input#addArtistField").val();
            document.title = $("input#addTitleField").val();
            document.description = $("textarea#addDescriptionField").val();
            document.creation_date = ( new Date() ).getTime();
            $.albums.saveDocument( document, {
                    success: function() {
                           $.mobile.changePage( "/albums/_design/albums/_list/albumIndex/albums", "slide", true, true );
                    },
                    error: function( status, error, reason ) {
                        alert( "Cannot save new document.\n" + status + ", " + reason + ", " + error );
                    }
              });
		}'.! !

!Albums methodsFor: 'as yet unclassified' stamp: 'JesusMari 9/7/2012 00:10'!
initEventlyAlbumDelete

(self evently at:'albumDelete' )
		onEvent:'deleteCancel' do:'function( event ){
       		var docId = $("#deleteFooter").data("identity");
        		$.mobile.changePage( "/albums/_design/albums/_show/album/" + docId, "slide", true, true );
        		return false;
    		}'; 
		onEvent:'deleteConfirm' do:'function( event ){
	        var docId = $("#deleteFooter").data("identity");
	        // First open doc based on ID in order to get the  latest _revision.
	        $db.openDoc( docId, {
	            success: function( document ){
	                // Then use the opened doc as reference to remove.
	                $.albums.deleteDocument( document, {
	                    success:function(){
	                        $.mobile.changePage( "/albums/_design/albums/_list/albumIndex/albums", "slide", true, true );
	                    },
	             	   error:function( status, error, reason ){
	                        alert( "Could not remove document with id: " + docId + "\n" + reason );
	                    }
	                });
	            },
	            error:function(){
	                alert( "Could not find document with id: " + docId );
	            }
	        });
	        return false;
	    }'! !

!Albums methodsFor: 'as yet unclassified' stamp: 'JesusMari 9/10/2012 18:17'!
initEventlyAlbumEdit

(self evently at:'albumEdit' )
		onEvent:'editCancel' do:
		'function( event ){
        		var docId = $("#albumEditPage").data("identity");
        		$.mobile.changePage( "/albums/_design/albums/_show/album/" + docId, "slide", true, true );
    		}'; 
		onEvent:'editConfirm' do:
		'function(e){
			var currentAlbum= $$(this).currentAlbum;
			currentAlbum.artist = $("input#artistField").val();
			currentAlbum.title = $("input#titleField").val();
			currentAlbum.description = $("textarea#descriptionField").val();

			$.albums.saveDocument( currentAlbum, {	
				success: function( response )  {
					$.mobile.changePage( "/albums/_design/albums/_show/album/" + currentAlbum._id,"flip", true, true );
				},
				error: function( status, error, reason ) {
					alert( "Cannot save document: " + document._id + "\n" + reason );
				}
			});
		}';
		onEvent:'_init' 
		data:'function(e){
			var docId = $("#albumEditPage").data("identity");
			var currentAlbum;
			$db.openDoc( docId, {
					success: function( document ) {
						currentAlbum=document;
						
					},
					error: function() {
						alert( "Cannot open document: " + docId );
					}
				},
				{async:false});
			$$(this).currentAlbum = currentAlbum;			
			return  $$(this).currentAlbum;
		}'
		mustache:
		'<form id="albumform" action="#" method="get" >
  			<div data-role="fieldcontain"> 
	        	<label for="artist">Artist:</label> 
	   	    	<input id="artistField" name="artist" type="text" value="{{artist}}" />
			</div>
			<div data-role="fieldcontain"> 
	        	<label for="title">Title:</label> 
	   	    	<input id="titleField" name="title" type="text" value="{{title}}" />
			</div>
			<div data-role="fieldcontain"> 
				<label for="description">Description:</label> 
				<textarea id="descriptionField" name="description" cols="40" rows="8">{{description}}</textarea> 
			</div>
		</form>'! !

!Albums methodsFor: 'as yet unclassified' stamp: 'JesusMari 1/14/2013 10:35'!
initEventlyAlbumSearch

(self evently at:'albumSearch' )
		onEvent:'searchCancel' do:
		'function( event ){
	   		$.mobile.changePage( "/albums/_design/albums/_list/albumIndex/albums", "slide", true, true );
    		}'; 
		onEvent:'searchConfirm' do:
		'function(e){
		var searchFieldContent = '''';
            searchFieldContent = $("input#searchField").val();
            $.mobile.changePage( "/albums/_design/albums/_list/albumSearch/albums?fieldContent=" + searchFieldContent, "slide", true, true );
		}'.! !

!Albums methodsFor: 'as yet unclassified' stamp: 'JesusMari 9/7/2012 05:18'!
initEventlyAlbumView

(self evently at:'albumView') 
		onEvent:'albumDelete' do:'function(e,data){
		// Access document id from data-identity.
		var docId = $("#albumcontent").data("identity");
		// Change page.
		$.mobile.changePage( "/albums/_design/albums/_show/album-delete/" + docId, "slideup", false, false );
		}'; 
		onEvent:'albumEdit' do:
		'function(e,data){
		// Access document id from data-identity.
		var docId = $("#albumcontent").data("identity");
		// Change page.
		$.mobile.changePage( "/albums/_design/albums/_show/album-edit/" + docId, "flip", false, true )
		}';
		onEvent:'albumLet' do:	
			'function(e,data){
			var docId = $("#albumcontent").data("identity");
			// Change page.
			$.albums.letDocument(docId, {
				"success": function(){$.mobile.changePage( "/albums/_design/albums/_show/album-users/" + docId, "flip", false, true );}
			});
		}' ! !

!Albums methodsFor: 'as yet unclassified' stamp: 'JesusMari 1/14/2013 10:47'!
initEventlyFooters

(self evently at:'albumFooter' onEvent:'_init')
	selector: '#deleteButton' 
	onClick:'function(){
			$(this).trigger(''albumDelete'');
			}';
	selector: '#editButton' 
	onClick:'function(){
			$(this).trigger(''albumEdit'');
			}';
	selector:'#letButton' 
	onClick:'function(){
			$(this).trigger(''albumLet'');
			}'. 
			
(self evently at:'deleteFooter' onEvent:'_init')
	selector: '#dialogCloseButton' 
	onClick:'function(){
			$(this).trigger(''deleteCancel'');
			}';	
	selector: '#deleteCancelButton' 
	onClick: 'function(){
			$(this).trigger(''deleteCancel'');
			}';
	selector: '#deleteConfirmButton' 
	onClick:'function(){
			$(this).trigger(''deleteConfirm'');
			}'. 



(self evently at:'editFooter' onEvent:'_init')
	selector: '#editCancelButton' 
	onClick:'function(){
			$(this).trigger(''editCancel'');
			}';	
	selector: '#editConfirmButton' 
	onClick:'function(){
			$(this).trigger(''editConfirm'');
			}'. 
			
		
(self evently at:'addFooter' onEvent:'_init')
	selector: '#addCancelButton' 
	onClick:'function(){
			$(this).trigger(''addCancel'');
			}';	
	selector: '#addConfirmButton' 
	onClick:'function(){
			$(this).trigger(''addConfirm'');
			}'. 
			
(self evently at:'searchFooter' onEvent:'_init')
	selector: '#searchCancelButton' 
	onClick:'function(){
			$(this).trigger(''searchCancel'');
			}';	
	selector: '#searchConfirmButton' 
	onClick:'function(){
			$(this).trigger(''searchConfirm'');
			}'. 
			
(self evently at:'loginCtrl' onEvent:'_init')
	selector: '#dialogCloseButton' 
	onClick:'function(){
			$(this).trigger(''loginCancel'');
			}';	
	selector: '#loginConfirmButton' 
	onClick:'function(){
			$(this).trigger(''loginConfirm'');
			}'. ! !

!Albums methodsFor: 'as yet unclassified' stamp: 'JesusMari 9/7/2012 04:53'!
initEventlyLoginDialog

(self evently at:'loginDialog' )
		onEvent:'loginCancel' do: 'function (e){$("#loginDialog").dialog(''close'');}';
		onEvent:'loginConfirm' do:
		'function(e,form){
			var username = $( "#username" ).attr(''value'');
  			var password = $( "#password" ).attr(''value'');
			//var uievent = ( ops.state == 0 ) ? "login" : "signup";
			$.albums.logIn(username,password);
			$(''#loginDialog'').dialog(''close'');
		}'! !

!Albums methodsFor: 'as yet unclassified' stamp: 'JesusMari 8/8/2012 20:19'!
initFilters
self addFilterAt:'mine'	
	put:
	[:doc :req|
		((doc user)= (req userCtx name)) 
	].
! !

!Albums methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/18/2013 19:47'!
initLists
self addListAt:'albumIndex' put:
[:head :req|	
		
self provides:'html' with:[:aHead :aReq|
	|doc stash albums template| 
	albums:=OrderedCollection new.
	[(doc:=self getRow ) isNil] whileFalse:[
		albums add: doc value.
		].

	template:=self templates at:'albumindex'.
	stash :=JsonObject fromAssociations: {
		'albums'->(albums asArray).
	}.
	self send: (Mustache toHtml:template view:stash partials: (self partials)).
	]
].


self addListAt:'albumSearch' put:
[:head :req|	
		
self provides:'html' with:[ :aHead :aReq|
	|doc stash albums template searchResults| 

	albums:=OrderedCollection new.

	searchResults:=(self indexerAt:'album-index') findPhrase: (aReq query at:'fieldContent')  minTarget: 0.8.

	[(doc:=self getRow ) isNil] whileFalse:[
		searchResults do:[:anAsociation|
		doc key = anAsociation key ifTrue:[albums add: doc value]
		] 
	].

	template:=self templates at:'albumindex'.
	stash :=JsonObject fromAssociations: {
		'albums'->(albums asArray).
	}.
	self send: (Mustache toHtml:template view:stash partials: (self partials)).
	]
]! !

!Albums methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/17/2013 08:42'!
initShows
self addShowAt: 'album-login' put: [:aDoc :req|
	|template|

	template:=self templates at:'albumlogin'.
	Mustache toHtml:template view:aDoc partials: (self partials).		
	].

self addShowAt: 'album' put: [:aDoc :req|
	|stash template|
	template:=self templates at:'album'.
	stash:= JsonObject fromAssociations:{
		'artist' -> (aDoc at:'artist').
		'title' ->( aDoc at:'title').
		'description' -> (aDoc at:'description').
		'user'-> (aDoc at:'user').
		'document' -> (aDoc at:'_id')
	}.
	Mustache toHtml:template view:stash partials: (self partials).		
	].

self addShowAt: 'album-delete' put: 
[:aDoc :req|
	|stash template|
	template:=self templates at:'albumdelete'.
	stash:= JsonObject fromAssociations:{
		'artist' -> (aDoc at:'artist').
		'title' ->( aDoc at:'title').
		'document' -> (aDoc at:'_id')
	}.
	Mustache toHtml:template view:stash partials: (self partials).		
	].


self addShowAt: 'album-edit' put: [:aDoc :req|
	|stash template|
	template:=self templates at:'albumedit'.
	stash:= JsonObject fromAssociations:{
		'artist' -> (aDoc at:'artist').
		'title' ->( aDoc at:'title').
		'description' -> (aDoc at:'description').
		'document' -> (aDoc at:'_id')
	}.
	Mustache toHtml:template view:stash partials: (self partials).		
	].

self addShowAt: 'album-users' put: [:aDoc :req|
	| template adminUsers userCollection stash|
	
	adminUsers:=((req at:'secObj') at:'admins') at:'names'.
	userCollection:=OrderedCollection new.
	adminUsers do:[:anUserName|
		userCollection add: (
			JsonObject fromAssociations: {'userName'->anUserName})
		].

	
	stash:= JsonObject fromAssociations:{
		'artist' -> (aDoc at:'artist').
		'title' ->( aDoc at:'title').
		'description' -> (aDoc at:'description').
		'document' -> (aDoc at:'_id').
		'loans'->(aDoc at:'loans').
		'admins'->(userCollection asArray)
	}.
	template:=self templates at:'albumusers'.

	Mustache toHtml:template view:stash partials: self partials.		
	].

self addShowAt: 'album-add' put: 
[:aDoc :req|
	|stash template|
	template:=self templates at:'albumadd'.
	Mustache toHtml:template view:stash partials: (self partials).		
	].


"
Depends on ObjectIndexer project
self addShowAt: 'album-search' put: 
[:aDoc :req|
	|stash template|
	template:=self templates at:'albumsearch'.
	Mustache toHtml:template view:stash partials: (self partials).		
	]."! !

!Albums methodsFor: 'as yet unclassified' stamp: 'JesusMari 8/21/2012 16:29'!
initUpdateHandler
self addUpdateHandlerAt: 'setNewUser' put:[:aDoc :req|
	|template stash loans|
	
	loans:=aDoc at:'loans'.
	loans ifNil:[loans:=OrderedCollection new]
		  ifNotNil:[loans:=OrderedCollection newFrom:loans].
	loans add:(JsonObject fromAssociations:{
							'user' -> ( req query newuser).
							'date' -> (DateAndTime now asString).
							}).
	aDoc at:'loans'  put:loans.
	template:=self templates at:'album'.
	stash:= JsonObject fromAssociations:{
		'artist' -> (aDoc at:'artist').
		'title' ->( aDoc at:'title').
		'description' -> (aDoc at:'description').
		'user' -> (aDoc at:'user').
		'document' -> (aDoc at:'_id').
	}.
	
	Array with:aDoc with:(Mustache toHtml:template view:stash partials: (self partials))
	].! !

!Albums methodsFor: 'as yet unclassified' stamp: 'JesusMari 1/12/2013 10:41'!
initValidator


self validateDocUpdate: [:newDoc :savedDoc :userContext|
| isDeletingWithoutPermission isUpdatingWithoutPermission isAlbumUser|
	isDeletingWithoutPermission:=false.
	isUpdatingWithoutPermission:=false.
	isAlbumUser:=(self isAdmin or:[ self userIs:'albums-user']).

	(userContext at:'name' ) 
	ifNil:[ ((UnauthorizedException new) messageText:'You need to be logged in order to do that.') signal]
	ifNotNil:[
		(isAlbumUser) ifFalse:[((ForbiddenException new) messageText: 'You do not have proper access to edit this document.') signal]
		].
	isDeletingWithoutPermission:=((newDoc at:'_deleted') notNil) and:[ (savedDoc user = userContext name) not].
	isUpdatingWithoutPermission:=(newDoc user = userContext name) not or:[
		savedDoc 
			ifNil:[false] 
			ifNotNil:[
				(newDoc user = savedDoc user) not.
			]].

	((self isAdmin not) and:[isDeletingWithoutPermission] ) 
	ifTrue:[
		
		((ForbiddenException new ) messageText:'Only the creator of this document has permission to delete') signal
	] ifFalse:[
		((self isAdmin  not) and:[isUpdatingWithoutPermission and:[(newDoc at:'_deleted') isNil ]] )
		 ifTrue:[
				((ForbiddenException new) messageText: 'Only the creator of this document has permission to update') signal
				] 
		ifFalse:[
				((newDoc at:'_deleted') = true) 
				ifFalse:[	self required:'user']
			]	
	]
]
! !

!Albums methodsFor: 'as yet unclassified' stamp: 'JesusMari 3/20/2013 19:37'!
initViews.
self addViewAt:'albums'	
	put:
	[:doc|
		self emit: doc key:(doc at:'creation_date')
	].

"self addViewAt:'indexe'	
	put:
	[:doc|
		(self indexerAt:'album-index') indexeMessages:( doc keys) by:#id from:doc. 

	]."

	

self addViewAt:'recent-items'	
	put:
	[:doc|
		self emit: (doc at:'creation_date') key:(doc at:'creation_date')
	]
	! !

!Albums methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/16/2013 19:15'!
initialize
super initialize.
self appName: 'albums'.
self language: 'smalltalk'.
self initViews.
self initShows.
self initLists.
self initEvently.
self initValidator.
self initUpdateHandler.
self initFilters.
self importAllAttachmentsFrom: 'D:\smalltalk\SCouchViewServer\Contents\Resources\albums\attachments\'.
self importAllTemplatesFrom: 'D:\smalltalk\SCouchViewServer\Contents\Resources\albums\templates\'.
self connectTo:'localhost' port:5984 userName:'admin' password:'admin'.
self upload.


! !

SCouchDBApp subclass: #HelloViewServer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-Application-Examples'!

!HelloViewServer methodsFor: 'as yet unclassified' stamp: 'JesusMari 9/14/2012 13:16'!
initEvently
self addEvently: EventlyAccount new. 
! !

!HelloViewServer methodsFor: 'as yet unclassified' stamp: 'JesusMari 7/29/2012 20:16'!
initViews
self addViewAt:'recent-items'	
	put:
	[:doc|
		((doc at:'type')='users') ifTrue:[
			self emit:doc key:(doc at:'_id')
		]
	].! !

!HelloViewServer methodsFor: 'as yet unclassified' stamp: 'JesusMari 2/16/2013 19:15'!
initialize
super initialize.
self initViews.
self initEvently.

self importVendorFilesFrom: 'D:\smalltalk\SCouchViewServer\Contents\Resources\hello\vendor\'.
self importAllAttachmentsFrom: 'D:\smalltalk\SCouchViewServer\Contents\Resources\hello\attachments\'.
self importAllTemplatesFrom: 'D:\smalltalk\SCouchViewServer\Contents\Resources\hello\templates\'.
self connectTo:'localhost' port:5984 userName:'admin' password:'admin'.
self upload.
! !

SCouchDBApp subclass: #SCouchAppTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-Application-Examples'!

!SCouchAppTest class methodsFor: 'as yet unclassified' stamp: 'JesusMari 5/28/2012 11:02'!
test
|aDoc db adaptor docArray docs |
self halt.

docs:= Array 
		with:(JsonObject fromAssociations:{	'artist'->'Thin Lizzy' .
														'title'->'Fighting'.
														'description'->'Bona-fide Rock classic'   											
											})					
		with:(JsonObject fromAssociations:   { 	'artist'->'David Bowie' .
														'title'->'Honky Dory'.
														'description'->'Doesn''t get much better than this'  
											}) .


adaptor:=SCouchDBAdaptor new 
	host: '127.0.0.1' 
	port: 5984 
	userName:'admin' 
	password:'95t5boru'.
db:= adaptor ensureDatabase: 'albums'.


docs do:[:d|
	db documentPut: d.
	]



"db deleteDocument: '1234556789A' revision:'1-67cb06c9c5c2ebd05c16fdd4a8b77528'.

docArray Nothing more expected ->:=db documentRevsInfoAt: '1234556789A'.
Transcript show: docArray asString.
Transcript show: adaptor users asString.
Transcript show: adaptor uuids asString.

docArray do:[:aDoc|
	Transcript show: aDoc asString.
]   "! !

!SCouchAppTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 8/8/2012 09:55'!
initFilters
self addFilterAt:'mine'	
	put:
	[:doc :req|
		((doc owner)= (req userCtx name)) 
		ifTrue:[true]
		ifFalse:[false]
	].

! !

!SCouchAppTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 3/20/2013 19:15'!
initLists
self addListAt:'argumentList' put:
[:head :req|	
self provides:'html' with:[:aHead :aReq|
	|doc|
	[(doc:=self getRow )] whileNotNil:[
		|val|
		val:=doc value.
		"Only tags with static content, do not include callback,etc "
		self sendOnCanvas:[:html|
			html heading level:2;with: (val aTag).
			html paragraph: (val aDescription).
			].
		]
	]
]! !

!SCouchAppTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 7/17/2012 17:22'!
initShows
self addShowAt:'helloWorld' put:
[:aDoc :req|
	self sendOnCanvas:[:html|
			html html:'
			<head>
				<title>CouchDB test</title>
				<meta http-equiv="Content-type" content="text/html; chanset=utf-8"/>
				<script src= "/_utils/script/json2.js"></script>
				<script src= "/_utils/script/sha1.js"></script>
				<script src= "/_utils/script/jquery.js?1.4.2"></script>
				<script src= "/_utils/script/jquery.couch.js?0.11.0"></script>
				<script src= "/_utils/script/jquery.dialog.js?0.11.0"></script>
			</head>'.
			html render: (JQSCouchDBTest new)
			].
	].


self addShowAt:'redirection' put:
[:aDoc :req|	
self redirectTo:'/_utils'
]! !

!SCouchAppTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 5/9/2012 20:02'!
initUpdates
self addUpdateHandlerAt:'argumentsToPepe'	
	put:
	[:doc :req|
		(doc owner) 
		ifNil:[Array with:nil with:' No hay na PEPE!!']
		ifNotNil:[
			doc owner:'pepe'.
			Array with:doc with:' To pa PEPE!!'].
		
		
	].

! !

!SCouchAppTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 7/16/2012 16:10'!
initValidator
self validateDocUpdate:
	[:newDoc :savedDoc :userContext|
		self field:'owner' shouldBe:userContext name.
		self assert:[newDoc includesKey:'_id'].		
	].

! !

!SCouchAppTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 5/6/2012 09:53'!
initViews
self addViewAt:'arguments'	
	put:
	[:doc|
		((doc at:'type')='argument') ifTrue:[
			self emit:doc key:(doc at:'aTag')
		]
	].


self addViewAt:'decisionsEdit'	
	put:
	[:doc |
	"view for decisions edition template"
		((doc at:'type')='decision') ifTrue:[
 	   		self emit:doc key: (doc at:'_id')
 	 	] 
	].


self addViewAt:'decisions'	
	put:[:doc| 
	|e|

	  ((doc  at:'type') ='decision') ifTrue:[
		e:=JsonObject new.
		e type:(doc at:'type');
		  description:(doc at:'description');
		  timesEvaluated:(doc at:'timesEvaluated').
		self emit: e key: (doc at:'_id').
	  ].
	"view for decisions list in the portal template"
].
self addViewAt:'dictionary'	
	put:[:doc| 
	((doc at:'type')='translation') ifTrue:[
		self emit:(doc at:'type') key:(Array with:(doc at:'language') with:(doc at:'of') with:(doc at:'text'))]
			]! !

!SCouchAppTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 3/20/2013 19:16'!
initialize
super initialize.

self language:'smalltalk'.
self initLists.
self initShows.
self initViews.
self initFilters.
self initUpdates.
self initValidator.
"TODO: multipart does not work yet..."
self includeDocs:true.
self importAllAttachmentsFrom: 'D:\smalltalk\SCouchViewServer\attachments\'.
self importAllTemplatesFrom: 'D:\smalltalk\SCouchViewServer\templates\'.
self connectTo:'localhost' port:5984 userName:'admin' password:'admin'.
self upload.
! !

!SCouchDBApp class methodsFor: 'as yet unclassified' stamp: 'JesusMari 1/6/2013 18:55'!
fromDictionary:aDic on:aViewServer
| a |
a:=super fromDictionary:aDic.
a server:aViewServer.
^a! !

!SCouchDBApp methodsFor: 'accessing' stamp: 'JesusMari 9/14/2012 13:13'!
addEvently:evently
self at:'evently' put:evently! !

!SCouchDBApp methodsFor: 'nodes' stamp: 'JesusMari 9/7/2012 01:13'!
addFilterAt:name put:aFilter

self filters at:name put: aFilter .! !

!SCouchDBApp methodsFor: 'nodes' stamp: 'JesusMari 9/7/2012 01:14'!
addListAt:name put:aList
self lists at:name put: aList .! !

!SCouchDBApp methodsFor: 'nodes' stamp: 'JesusMari 6/19/2012 11:41'!
addMustacheTemplate:aTemplate
self templates at:(aTemplate name asString) put:(aTemplate instance render)! !

!SCouchDBApp methodsFor: 'nodes' stamp: 'JesusMari 9/7/2012 01:14'!
addShowAt:name put:aShow

self shows at:name put: aShow.! !

!SCouchDBApp methodsFor: 'nodes' stamp: 'JesusMari 9/7/2012 01:15'!
addSignatureAt:name put:aSignature
self signatures at:name put:aSignature.! !

!SCouchDBApp methodsFor: 'nodes' stamp: 'JesusMari 9/7/2012 01:16'!
addUpdateHandlerAt:name put:anUpdater

self updates at:name put: anUpdater.! !

!SCouchDBApp methodsFor: 'nodes' stamp: 'JesusMariAguirre 5/15/2012 22:03'!
addViewAt:name put:aView

self addViewAt:name put:aView  reduce:nil! !

!SCouchDBApp methodsFor: 'nodes' stamp: 'JesusMari 9/7/2012 01:17'!
addViewAt:name put:aView reduce:aReduceFunction
|v aViewCode aReduceCode|

v:=JsonObject new.
aViewCode:= (aView isKindOf: BlockClosure) 
				ifTrue:[aView]
				ifFalse:[aView asString ].

v map:(aViewCode).

aReduceCode:= (aReduceFunction isKindOf: BlockClosure) 
				ifTrue:[aReduceFunction]
				ifFalse:[aReduceFunction asString ].
aReduceFunction ifNotNil:[v at:'reduce' put:(aReduceCode)].
self views at:name put:v.
! !

!SCouchDBApp methodsFor: 'accessing' stamp: 'JesusMari 5/28/2012 11:29'!
appName
	appName ifNil:[appName:= self class asString translateToLowercase ].
	^ appName! !

!SCouchDBApp methodsFor: 'accessing' stamp: 'JesusMari 4/24/2012 14:32'!
appName: anObject
	appName := anObject! !

!SCouchDBApp methodsFor: 'initialization' stamp: 'JesusMari 8/30/2012 12:57'!
connectTo:aHost port:aPort userName:aUserName password:aPassword

dbAdaptor:=SCouchDBAdaptor new host: aHost port: aPort userName:aUserName password:aPassword.



	! !

!SCouchDBApp methodsFor: 'accessing' stamp: 'JesusMari 4/24/2012 17:42'!
database
	database ifNil:[database:=self class asString asLowercase].
	^ database! !

!SCouchDBApp methodsFor: 'accessing' stamp: 'JesusMari 4/24/2012 12:18'!
database: anObject
	database := anObject! !

!SCouchDBApp methodsFor: 'accessing' stamp: 'JesusMari 9/7/2012 00:06'!
evently
^ self at:'evently' ifAbsent:[self at:'evently' put:(SCEvently new)]! !

!SCouchDBApp methodsFor: 'accessing' stamp: 'JesusMari 7/20/2012 18:17'!
filters
^ self at:'filters' ifAbsent:[self at:'filters' put:(JsonObject new)]! !

!SCouchDBApp methodsFor: 'import' stamp: 'JesusMari 7/31/2012 01:50'!
importAllAttachmentsFrom:aFolderPath
self importAllAttachmentsFrom:aFolderPath relPath:'' prefix:''
! !

!SCouchDBApp methodsFor: 'private' stamp: 'JesusMari 7/31/2012 02:09'!
importAllAttachmentsFrom:aFolderPath relPath:relPath prefix: aPrefix
| dir a elements attchPath |

dir:= FileDirectory on: (aFolderPath , relPath).
elements :=dir entries.
elements do:[:entry|
	(entry isDirectory) 
	ifTrue:[
		(relPath='') 
			ifTrue:[	self importAllAttachmentsFrom:aFolderPath relPath:(entry name) prefix:aPrefix]
			ifFalse:[	self importAllAttachmentsFrom:aFolderPath relPath:(relPath , FileDirectory pathNameDelimiter asString, entry name) prefix:aPrefix]
	]
	ifFalse:[
		
	
		a :=SCouchDBAttachment fromFile: (aFolderPath,relPath , FileDirectory pathNameDelimiter asString, entry name) includeDoc:self includeDocs. 

		(relPath='') 
			ifFalse:[attchPath:=(relPath , FileDirectory pathNameDelimiter asString, entry name)]
			ifTrue:[attchPath:=( entry name)].
		attchPath:= attchPath copyReplaceAll: '\' with: '/'.
		a name:  attchPath.
		self addAttachmentAt: (aPrefix,attchPath) put: a  

	]
]
! !

!SCouchDBApp methodsFor: 'import' stamp: 'JesusMari 7/31/2012 02:14'!
importAllEventlyFilesFrom:aFolderPath 
self importVendorFilesFrom:aFolderPath relPath:'' stack: self evently! !

!SCouchDBApp methodsFor: 'import' stamp: 'JesusMari 10/4/2012 18:23'!
importAllTemplatesFrom:aFolderPath 
|i|
i:=Mustache instanceFromFolder:aFolderPath.
self at:'templates' put:i! !

!SCouchDBApp methodsFor: 'private' stamp: 'JesusMari 7/12/2012 10:54'!
importAllTemplatesFrom:aFolderPath relPath:relPath
| dir a elements attchPath fileName aStream |

dir:= FileDirectory on: (aFolderPath , relPath).
elements :=dir entries.
elements do:[:entry|
	(entry isDirectory) 
	ifTrue:[
		(relPath='') 
			ifTrue:[	self importAllTemplatesFrom:aFolderPath relPath:(entry name)]
			ifFalse:[	self importAllTemplatesFrom:aFolderPath relPath:(relPath , FileDirectory pathNameDelimiter asString, entry name)]
	]
	ifFalse:[
		fileName:= entry name copyFrom:1 to:((entry name indexOf:$.) - 1). 
		(relPath='') 
			ifFalse:[
				attchPath:=(relPath , FileDirectory pathNameDelimiter asString, fileName).
				attchPath:= attchPath copyReplaceAll: '\' with: '/'.
				aStream := StandardFileStream readOnlyFileNamed: entry fullName.	
				aStream ascii.
				self partials at: attchPath put: (aStream contents)
				]
			ifTrue:[
				attchPath:= fileName.
				aStream := StandardFileStream readOnlyFileNamed: entry fullName.	
				aStream ascii.
				self templates at: attchPath put: (aStream contents)
				].
	]
]! !

!SCouchDBApp methodsFor: 'import' stamp: 'JesusMari 7/31/2012 01:36'!
importVendorFilesFrom:aFolderPath 
self importVendorFilesFrom:aFolderPath relPath:'' stack: self vendor! !

!SCouchDBApp methodsFor: 'private' stamp: 'JesusMari 7/31/2012 02:09'!
importVendorFilesFrom:aFolderPath relPath:relPath stack:currentJsonObject
| dir a elements attchPath fileName aStream aTempl |

dir:= FileDirectory on: (aFolderPath , relPath).
elements :=dir entries.
elements do:[:entry|
	(entry isDirectory) 
	ifTrue:[
		((entry name) = '_attachments') 
		ifTrue:[
			self importAllAttachmentsFrom: (aFolderPath , relPath , FileDirectory pathNameDelimiter asString, entry name) relPath:'' prefix: (('vendor',relPath,'/' ) copyReplaceAll: '\' with: '/').
			]
		ifFalse:[
			currentJsonObject at: entry name put: JsonObject new.
			self importVendorFilesFrom:aFolderPath 
				relPath:(relPath , FileDirectory pathNameDelimiter asString, entry name)
				stack:(currentJsonObject at: entry name).]
	]
	ifFalse:[
		fileName:= entry name copyFrom:1 to:((entry name indexOf:$.) - 1). 
		aStream := StandardFileStream readOnlyFileNamed: entry fullName.	
		currentJsonObject at: fileName put: (
			 [Json readFrom: (SCouchUTF8Stream on: aStream)]
						on:Exception 
						do:[aStream contents]
			)
	]
]! !

!SCouchDBApp methodsFor: 'accessing' stamp: 'JesusMariAguirre 5/16/2012 13:14'!
includeDocs
^includeDocs! !

!SCouchDBApp methodsFor: 'accessing' stamp: 'JesusMariAguirre 5/16/2012 13:14'!
includeDocs:aBool
includeDocs:=aBool! !

!SCouchDBApp methodsFor: 'accessing' stamp: 'JesusMari 1/12/2013 11:06'!
indexPath
^ self at:'indexPath' ifAbsent:[self at:'indexPath' put: (self appName , '- index')]! !

!SCouchDBApp methodsFor: 'initialization' stamp: 'JesusMari 7/17/2012 16:05'!
initialize:size
super initialize:size.
includeDocs:=false.
self language:'smalltalk'.
self includeDocs: true.
self initialize
! !

!SCouchDBApp methodsFor: 'accessing' stamp: 'JesusMari 4/8/2012 15:27'!
language
	^self at:'language'! !

!SCouchDBApp methodsFor: 'accessing' stamp: 'JesusMari 4/8/2012 15:27'!
language: anObject
	self at:'language' put: anObject! !

!SCouchDBApp methodsFor: 'accessing' stamp: 'JesusMari 7/30/2012 09:08'!
lib
^ self at:'lib' ifAbsent:[self at:'lib' put:(JsonObject new)]! !

!SCouchDBApp methodsFor: 'accessing' stamp: 'JesusMari 4/8/2012 15:28'!
lib: anObject
	self at:'lib' put: anObject! !

!SCouchDBApp methodsFor: 'accessing' stamp: 'JesusMari 7/20/2012 18:05'!
lists
^ self at:'lists' ifAbsent:[self at:'lists' put:(JsonObject new)]! !

!SCouchDBApp methodsFor: 'accessing' stamp: 'JesusMari 5/26/2012 16:58'!
partials
| templates |
templates:= self at:'templates' ifAbsent:[self at:'templates' put:(JsonObject new)].
^ templates at:'partials' ifAbsent:[(self at:'templates') at:'partials' put:(JsonObject new)]! !

!SCouchDBApp methodsFor: 'nodes' stamp: 'JesusMari 5/9/2012 19:01'!
removeFilter:aFilter

(self at:'filters' ) removeKey:aFilter.! !

!SCouchDBApp methodsFor: 'nodes' stamp: 'JesusMari 4/9/2012 10:56'!
removeList:aList

(self at:'lists' ) removeKey:aList.! !

!SCouchDBApp methodsFor: 'nodes' stamp: 'JesusMari 4/9/2012 10:58'!
removeShow:aShow
(self at:'shows' ) removeKey:aShow! !

!SCouchDBApp methodsFor: 'nodes' stamp: 'JesusMari 4/9/2012 10:58'!
removeSignature:aSignature
(self at:'signatures' ) removeKey:aSignature! !

!SCouchDBApp methodsFor: 'nodes' stamp: 'JesusMari 5/9/2012 19:56'!
removeUpdateHandler:anUpdater

(self at:'updates' ) removeKey:anUpdater.! !

!SCouchDBApp methodsFor: 'nodes' stamp: 'JesusMari 4/9/2012 10:58'!
removeView:aView
(self at:'views' ) removeKey:aView.! !

!SCouchDBApp methodsFor: 'accessing' stamp: 'JesusMari 3/15/2013 09:32'!
runner
	^self
! !

!SCouchDBApp methodsFor: 'private' stamp: 'JesusMari 2/3/2013 13:12'!
shows
"shows node for CouchDB show functions"
^ self at:'shows' ifAbsent:[self at:'shows' put:(JsonObject new)]! !

!SCouchDBApp methodsFor: 'accessing' stamp: 'JesusMari 9/7/2012 01:15'!
signatures
^ self at:'signatures' ifAbsent:[self at:'signatures' put:(JsonObject new)]! !

!SCouchDBApp methodsFor: 'accessing' stamp: 'JesusMari 2/3/2013 13:11'!
templates
"updates node for Mustache Templates"
^ self at:'templates' ifAbsent:[self at:'templates' put:(JsonObject new)]! !

!SCouchDBApp methodsFor: 'accessing' stamp: 'JesusMari 2/3/2013 13:11'!
updates
"updates node for CouchDB update functions"
^ self at:'updates' ifAbsent:[self at:'updates' put: JsonObject new].
! !

!SCouchDBApp methodsFor: 'initialization' stamp: 'JesusMari 2/3/2013 13:10'!
upload
|db attchs |
"Upload the application and put the compiled block inside the application cache"
dbAdaptor ifNil:[^nil].

(self language = 'smalltalk') ifTrue:[
	"include the app in the CouchViewServer cache (only for smalltalk language)"
	SCouchDBViewServer servers do:[:aServer| 
	aServer designDocs at:('_design/', self appName) put:self ]].
db:=dbAdaptor ensureDatabase: self database.
db documentAt:('_design/', self appName) put: self.	! !

!SCouchDBApp methodsFor: 'accessing' stamp: 'JesusMari 7/28/2012 16:56'!
validateDocUpdate
	^ self at:'validate_doc_update' ifAbsent:[self at:'validate_doc_update' put:'[]']! !

!SCouchDBApp methodsFor: 'accessing' stamp: 'JesusMari 8/20/2012 19:42'!
validateDocUpdate: anObject
	self at:'validate_doc_update' put: anObject ! !

!SCouchDBApp methodsFor: 'accessing' stamp: 'JesusMari 7/31/2012 01:37'!
vendor
^ self at:'vendor' ifAbsent:[self at:'vendor' put:(JsonObject new)]! !

!SCouchDBApp methodsFor: 'accessing' stamp: 'JesusMari 7/20/2012 18:20'!
views
^ self at:'views' ifAbsent:[self at:'views' put:(JsonObject new)]! !

SCouchDBApp subclass: #Tutorial
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-Application-Evently-Examples'!

!Tutorial methodsFor: 'as yet unclassified' stamp: 'JesusMari 9/7/2012 00:05'!
initChoices

self evently at: 'choices' 
	onEvent:'_init'	
	mustache: '<p>You won a free topping!! what would you like it to be?</p>
<ul>
	<li><a href="#cheese">Cheese</a></li>
	<li><a href="#bacon">bacon</a></li>
	<li><a href="#chili">chili</a></li>
	<li><a href="#tomatoes">tomatoes</a></li>
</ul>'.

(self evently at: 'choices' 
	onEvent:'_init')
	selector:'a[href=#cheese]'
	onClick:'function(){
			$(this).trigger(''addTopping'',''cheese'');
			}';
	selector: 'a[href=#bacon]' 
	onClick:'function(){
			$(this).trigger(''addTopping'',''bacon'');
			}';			
	selector: 'a[href=#chili]' 
	onClick:'function(){
			$(this).trigger(''addTopping'',''chili'');
			}';				
	selector: 'a[href=#tomatoes]' 
	onClick:'function(){
			$(this).trigger(''addTopping'',''tomatoes'');
			}'.

			
		! !

!Tutorial methodsFor: 'as yet unclassified' stamp: 'JesusMari 9/7/2012 00:05'!
initExamples

(self evently at: 'examples' 
onEvent:'_init'
mustache:'<p>A feq examples that could inspire you:</p>
<ul>
{{#examples}}
	<li>{{value}}</li>
{{/examples}}
</ul>
'
data:'function (data){
return { examples: data.rows};
}
' ) query view:'toppings';limit: 2.
! !

!Tutorial methodsFor: 'as yet unclassified' stamp: 'JesusMari 9/7/2012 00:04'!
initItems

self evently at: 'items'
	onEvent:'_init'
	data:  'function(e){$$(this).toppings = [];}'
	mustache:'<p>Items served by evently<p>'.
	
self evently at: 'items' 
	onEvent:'topping'
	data:'function (e,topping){
	return {toppings : $$(this).toppings};}'
	mustache:'<p>Oh, you want on your pizza</p>
<ul>
{{#toppings}}
	<li>{{top}}</li>
{{/toppings}}
</ul>'.

self evently at: 'items'  
onEvent:'addTopping'
do:'function(e,topping){
	$$(this).toppings.push({"top":topping});
	$(this).trigger(''topping'');
}'
! !

!Tutorial methodsFor: 'as yet unclassified' stamp: 'JesusMari 6/18/2012 06:19'!
initViews
self addViewAt: 'toppings' put:[:doc|
	((doc at:'type' ifAbsent:[nil])= 'topping') ifTrue: [
			self emit:(doc at:'contents') key:nil.
		]
	] ! !

!Tutorial methodsFor: 'as yet unclassified' stamp: 'JesusMari 9/1/2012 22:45'!
initialize
super initialize.
self initItems.
self initExamples.
self initChoices.
self initViews.
self importAllAttachmentsFrom: 'D:\smalltalk\SCouchViewServer\Contents\Resources\tutorial\attachments\'.
"self importAllEventlyFilesFrom: 'D:\smalltalk\SCouchViewServer\Contents\Resources\tutorial\evently\'."
self connectTo:'localhost' port:5984 userName:'admin' password:'95t5boru'.
self upload.! !

!BlockClosure methodsFor: '*scouchdb-application-core' stamp: 'JesusMari 7/27/2012 21:27'!
sourceCode
|sc|

sc:= self decompile asString.
((sc at:1) = ${) ifTrue:[
	^ sc copyFrom:2 to: (sc size - 1)
	].
^ sc! !

!SCouchHTTPResponse methodsFor: '*SCouchDB-Application' stamp: 'JesusMari 4/9/2012 12:33'!
etag

	| tmp |
	tmp:= header at: 'etag' ifAbsent: [nil].
	tmp ifNil:[^tmp] ifNotNil:[^tmp withoutQuoting]! !

!SCouchDatabase methodsFor: '*scouchdb-application-core' stamp: 'JesusMari 8/25/2012 12:30'!
arrayOfMultipartsFrom:content
|anArray text  first rStream |

anArray := OrderedCollection new.

first:= 	'content-type: application/json' ,String crlf,String crlf , (self utf8Encode: content asJsonString).
rStream:= ReadStream on:first from:1 to:first size.
anArray add:rStream.

(content at:'_attachments') do:[:attch|
	anArray  add:attch stream	
].

^anArray



		

! !

!SCouchDatabase methodsFor: '*scouchdb-application-core' stamp: 'JesusMariAguirre 5/16/2012 10:23'!
boundary
^ adaptor boundary! !

!SCouchDatabase methodsFor: '*scouchdb-application-core' stamp: 'JesusMariAguirre 5/14/2012 09:49'!
documentCurrentRevAt: id 

	| response result |
	(id asString beginsWith: '_') 
	ifTrue: 
	[response := adaptor head: self namePrefix , id asString]	
	ifFalse:
	[response := adaptor head: self namePrefix , id asString encodeForHTTP].

	result := response etag. 
	
	response code = HTTPOK ifTrue: [ ^ result ].
	^ adaptor couchDBError: result! !

!SCouchDatabase methodsFor: '*scouchdb-application-core' stamp: 'JesusMari 4/9/2012 14:02'!
documentRevisionsAt: id 

	| response result |
	response := adaptor get: self namePrefix , id asString ,
		'?revs=true'.

	result := adaptor readJsonFrom: response.
	response code = HTTPOK ifTrue: [ ^ result ].
	^ adaptor couchDBError: result! !

!SCouchDatabase methodsFor: '*scouchdb-application-core' stamp: 'JesusMari 4/9/2012 14:03'!
documentRevsInfoAt: id 

	| response result |
	
	response := adaptor get: self namePrefix , id asString  encodeForHTTP ,
		'?revs_info=true' .

	result := adaptor readJsonFrom: response.
	response code = HTTPOK ifTrue: [ ^ result ].
	^ adaptor couchDBError: result! !
